library mircglass;
uses
  mIRC,
  Windows,
  Messages,
  JwaDwmApi,
  JwaUxTheme;
type
  TmIRCDLL = packed record
    mVersion : DWORD;
    mHwnd    : HWND;
    mKeep    : Boolean;
  end;
  PmIRCDLL = ^TmIRCDLL;
type
  TWindow = record
   nome : string;
   hwnd : hwnd;
   Proc : pointer;
end;
type TWinVersion = (wvUnknown, wvWin95, wvWin98, wvWin98SE, wvWinNT, wvWinME, wvWin2000, wvWinXP, wvWinVista) ;
const
 ErrUINT = High(Cardinal);
 TV_FIRST                 = $1100;
 TVS_EX_FADEINOUTEXPANDOS = $0040;
 TVM_SETEXTENDEDSTYLE     = TV_FIRST + 44;
 TVM_GETEXTENDEDSTYLE     = TV_FIRST + 45;
var
  mIRCMVOF : pointer;
  mwnd_ : hwnd;
  CFM: Cardinal;
  win:array[0..100] of TWindow; { infos das window }
function SetWindowTheme(hwnd: HWND; pszSubAppName: LPCWSTR; pszSubIdList: LPCWSTR): HRESULT; stdcall;  external 'uxtheme.dll';
function GetData(data: string): pchar; { pega qualquer coisa do mirc. Ex.: $me, $dialog().hwnd etc }
begin
  lstrcpy(mIRCMVOF,pchar(data));
  SendMessage(mwnd_,WM_USER + 201,1,0);
  Result := mIRCMVOF;
end;
procedure SendData(data: string); { envia comando pra o mirc (/run, /exit, /echo, etc) }
begin
  lstrcpy(mIRCMVOF,pchar(data));
  SendMessage(mwnd_,WM_USER + 200,1,0);
end;
procedure Erro(Erro: string = ''); { mostra erro no status e janela ativa como os do mirc }
begin
  if Erro = '' then
    Erro := 'erro desconhecido';
  SendData('//echo $color(info) -esa * hurricane.dll: ' +Erro);
end;
procedure Signal(Mensagem: string); { manda o signal com a MSG pra o mirc }
begin
  SendData('/.signal ' +mensagem)
end;
function GetHwnd(Window: String): hWnd;
begin
  Result := strtoint(GetData('$dialog('+Window+').hwnd'));
  if (IsWindow(Result)) then exit;
  Result := strtoint(GetData('$window('+Window+').hwnd'));
  if (IsWindow(Result)) then exit;
  Erro('dialog/@window invlida');
  Result := 0;
end;
procedure LoadDll(mIRCDLL: PmIRCDLL); stdcall; export;
begin
  mIRCDLL.mKeep := true;
  mwnd_ := mIRCDLL.mHwnd;

  CFM := CreateFileMapping(INVALID_HANDLE_VALUE,nil,PAGE_READWRITE,0,1024,'mIRC');
  mIRCMVOF := MapViewOfFile(CFM,FILE_MAP_ALL_ACCESS,0,0,0);
end;
function UnloadDll(mTimeOut: integer):integer; stdcall; export;
begin
  Result := 0;
  if mTimeOut = 0 then begin
    UnmapViewOfFile(mIRCMVOF);
    CloseHandle(CFM);
  end;
end;
function WinNum(Hwnd : hwnd):integer; { retorna o numero da window, ou se for 0 diz um numero vazio }
var
  n : integer;
begin
  n := 0;
  while n <= 100 do begin
    if win[n].hwnd = hwnd then begin
      result := n;
      exit
    end
    else
      inc(n);
  end;
  result := -1;
end;
function GetWinVersion: TWinVersion;
var
   osVerInfo: TOSVersionInfo;
   majorVersion, minorVersion: Integer;
begin
   Result := wvUnknown;
   osVerInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo) ;
   if GetVersionEx(osVerInfo) then
   begin
     minorVersion := osVerInfo.dwMinorVersion;
     majorVersion := osVerInfo.dwMajorVersion;
     case osVerInfo.dwPlatformId of
       VER_PLATFORM_WIN32_NT:
       begin
         if majorVersion <= 4 then
           Result := wvWinNT
         else if (majorVersion = 5) and (minorVersion = 0) then
           Result := wvWin2000
         else if (majorVersion = 5) and (minorVersion = 1) then
           Result := wvWinXP
         else if (majorVersion = 6) then
           Result := wvWinVista;
       end;
       VER_PLATFORM_WIN32_WINDOWS:
       begin
         if (majorVersion = 4) and (minorVersion = 0) then
           Result := wvWin95
         else if (majorVersion = 4) and (minorVersion = 10) then
         begin
           if osVerInfo.szCSDVersion[1] = 'A' then
             Result := wvWin98SE
           else
             Result := wvWin98;
         end
         else if (majorVersion = 4) and (minorVersion = 90) then
           Result := wvWinME
         else
           Result := wvUnknown;
       end;
     end;
   end;
end;
function DWM_EnableBlurBehind(hwnd : HWND; AEnable: Boolean; hRgnBlur : HRGN = 0; ATransitionOnMaximized: Boolean = False; AFlags: Cardinal = 1): HRESULT;
var
  bb : DWM_BLURBEHIND;
begin
  bb.dwFlags:=AFlags;
  bb.fEnable:=AEnable;
  bb.hRgnBlur:=hRgnBlur;
  bb.fTransitionOnMaximized:=ATransitionOnMaximized;
  Result:=DwmEnableBlurBehindWindow(hwnd, bb);
end;
function glass(mWnd: hWnd; aWnd: hWnd; Data: PChar; Parms: PChar; Show: Boolean; NoPause: Boolean; ATopHeight, ALeftWidth, ABottomHeight, ARightWidth: Integer ): Integer; export; stdcall;
var
  hjanela : hwnd;
  lMargins : Margins;
begin
  hjanela := gethwnd(gettok(data,' ',1));
  if GetWinVersion = wvWinVista then
  begin
    lMargins.cyTopHeight := strtoint(gettok(data,' ',2));
    lMargins.cyBottomHeight := strtoint(gettok(data,' ',3));
    lMargins.cxLeftWidth := strtoint(gettok(data,' ',4));
    lMargins.cxRightWidth := strtoint(gettok(data,' ',5));
    DwmExtendFrameIntoClientArea(hjanela, lMargins);
  end;
  Result := 1;
end;
//mIRC Glass //dll vistaglass.dll glass $dname -1 -1 -1 -1
exports
  LoadDll,UnloadDll,glass;
begin
end.
